--[[
	SRB2Persona randomizer by Lamibe
		This mod is a randomizer even if there banskin too 
	And yes that still a mess
	
		Also nice that Tartarus never change map so it work without much changes
]]

if not srb2p then print("This mod have to be used with SRB2Persona") return end

local helpText = {["main"] = "Persona Randomizer v2 \nUse rt_help <topic> to get help about a topic.\nTopics :\n  random : About the randomizer.\n  banskin : About skin ban.",
["random"] = "Randomize characters of each team. \nVariables : \n  rt_rand_randskin : Randomize the skins of each team. \n  rt_rand_noduplicate : Prevents duplicates of characters in randomized team(or reduce them if not enough skin).",
["banskin"] = "Ban a skin. \nCommands : \n  rt_ban_banskin <skin> : Ban the skin. \n  rt_ban_unbanskin <skin> : Unban the skin. \n  rt_ban_list : List banned skins.\n  rt_ban_clear : Unban every skin. \n  rt_ban_allowonly <skin> : Ban every skin except this one."
}

local randomizer = CV_RegisterVar({"rt_rand_randskin", "off", CV_NETVAR|CV_SHOWMODIF, CV_OnOff}) -- Should we enable the randomizer
local nodupli = CV_RegisterVar({"rt_rand_noduplicate", "off", CV_NETVAR, CV_OnOff}) -- Don't randomize the same character twice in the same team

local bannedSkin = {}

local function banSkin(skin, ban)
	if(skin == nil) then return false end
	if(type(skin) == "string") then
		local skinname = skin
		skin = -1
		for i=0, #skins - 1 do
			if(skins[i].valid and skins[i].name == skinname) then skin = i break end
		end
	end
	local c = 0
	if ban == nil then ban = true end
	if((skin >= 0 and skin<#skins) and skins[skin].valid) then 
		bannedSkin[skins[skin].name] = ban
		return true
	else
		return false
	end
end

-- Is a skin usable ?
local function isSkinValid(skin, possibleSkin, ignoreDupli)
	if (not skins[skin].valid) then return false end -- The skin must exists of course
	
	if nodupli.value and ignoreDupli == false then
		if (possibleSkin[skin] <= 0) then -- There is no more of this skin available
			return false
		end
	end
	if(bannedSkin[skins[skin].name]) then return false end
	if(skins[skin].name == "random") then return false end -- Don't randomize to random thanks
	
	return true
end

local function randomizeChar(team, slot, possibleSkin)
	local skin
	local ignore = false
	if(not possibleSkin) then ignore = true end
	repeat
		skin = P_RandomKey(#skins)
	until(isSkinValid(skin, possibleSkin, ignore)) --Stupid loop as I'm too lazy to search another way to do so
	if(team ~= nil)
		server.P_netstat.skinlist[team][slot] = skins[skin].name --That what I mean by deep variable. This is actually what is changed when you select a skin
		if(not ignore) then possibleSkin[skin] = $ - 1 end
		--print("Randomize "..team..":"..slot.." to "..skins[skin].name)
	end
	return skins[skin].name
end

addHook("MapChange", function(mapnum)
	-- Randomize skins
	local net = server.P_netstat -- Yes because changing it normally don't work
	if not net then return end
	if(randomizer.value) then
		local possibleSkin = {} -- UsedSkin because once
		
		--Count possible skins to deduct how much duplicate we can allow
		local c = 0
		for i = 0, #skins-1 do
			if(isSkinValid(i, possibleSkin, true)) then c = $ + 1 end
		end
		--Don't say we have no skin. So explain me how the game didn't crashed
		if(c==0) then
			print("No skin available")
			return
		end
		local maxDupli = FixedCeil(FixedDiv(4*FRACUNIT,c * FRACUNIT)) / FRACUNIT -- How much duplicate we allow
		
		for team = 1, 4 do --Each team
			if not net.leaders[team] then continue end -- Only existing teams(the ones with leader)
			
			--Clear skin availability
			for i = 0, #skins-1 do
				-- Don't create infinite loop if every skin is used
				possibleSkin[i] = maxDupli
			end
			
			for slot = 1, 4 do --Each players
				randomizeChar(team, slot, possibleSkin)
			end
		end
	else --Still clear these "random" character
		for team = 1, 4 do --Each team
			if not net.leaders[team] then continue end -- Only existing teams(the ones with leader)
			
			for slot = 1, 4 do --Each players
				if(net.skinlist[team][slot] == "random") then --If they use "random" then randomize
					randomizeChar(team, slot)
				end
			end
		end
	end
end)

addHook("PlayerThink",function(player)
	if not player or not player.mo then return end
	if player.mo.skin == "random" then --We don't want random
		local skin = randomizeChar()
		COM_BufInsertText(player, "skin "..skin)
		--print("Randomized "..player.name.."'s skin to "..skin)
	end
end)

--Sync
addHook("NetVars", function(net)
	bannedSkin = net($)
end)

-- Print help
COM_AddCommand("rt_help", function(player, topic)
	if(not topic or not helpText[topic]) then topic = "main" end
	CONS_Printf(player, helpText[topic])
end)

--Ban skin commands
COM_AddCommand("rt_ban_banskin", function(player, skin)
	if(not skin) then CONS_Printf(player, "Usage : rt_ban_banskin <skin>")
		return	
	end
	local c = 0
	for i=0, #skins - 1 do
		if(skins[i].valid and not bannedSkin[skins[skin].name]) then c = $ + 1 break end
	end
	if(c<=1) then
		CONS_Printf(player, "You cannot ban every skin")
		return false
	end
	if(banSkin(skin, true)) then
		print("Skin \""..skin.."\" is now banned")
	else
		CONS_Printf(player, "Skin \""..skin.."\" don't exists")
	end
end, COM_ADMIN)

COM_AddCommand("rt_ban_unbanskin", function(player, skin)
	if(not skin) then CONS_Printf(player, "Usage : rt_ban_unbanskin <skin>") 
		return
	end
	if(banSkin(skin, false)) then
		print("Skin \""..skin.."\" is no longer banned")
	else
		CONS_Printf(player, "Skin \""..skin.."\" don't exists")
	end
end, COM_ADMIN)

COM_AddCommand("rt_ban_list", function(player)
	CONS_Printf(player, "List of banned skin : ")
	for k, v in pairs(bannedSkin) do
		if(v) then CONS_Printf(player, k) end
	end
end)

COM_AddCommand("rt_ban_allowonly", function(player, skin)
	if(not skin) then CONS_Printf(player, "Usage : rt_ban_allowonly <skin>") 
		return
	end
	local valid = false
	for i=0, #skins - 1 do
		if(skins[i].valid and skins[i].name == skin) then valid = true break end
	end
	if(not valid) then
		CONS_Printf(player,"Skin \""..skin.."\" don't exists")
		return
	end
	for i=0, #skins - 1 do
		if(skins[i].valid) then 
			if(skins[i].name == skin) then banSkin(skins[i].name,false)
			else banSkin(skins[i].name,true) end
		end
	end
	print("Every skin except \""..skin.."\" are now banned")
end, COM_ADMIN)

COM_AddCommand("rt_ban_clear", function(player)
	for i=0, #skins - 1 do
		if(skins[i].valid) then 
			banSkin(skins[i].name,false)
		end
	end
end, COM_ADMIN)

-- Just fuck for banskin let hook a function which already prevents the use of a skin
local P_netUnlockedCharacter_real = P_netUnlockedCharacter

rawset(_G, "P_netUnlockedCharacter", function(p, charname)
	if(P_netUnlockedCharacter_real(p, charname)) then
		if bannedSkin[charname] then return false
		else return true end
	end
	return false
end)

--The random character
charStats.random = {

		-- GENERAL

		name = "Random",			-- This is only for bots / enemies
		basehp = 1,			-- base HP for level 1
		basesp = 1,
		persona = "orpheus",
		melee_natk = "sonic_atk1",	-- normal melee attack
		--melee_satk = "ssonic_atk1",	-- normal melee attack when super

		atk = 1,	-- attack power of physical attacks
		acc = 1,	-- accuracy of physical attacks
		crit = 1,

		supercolor_start = SKINCOLOR_SUPERGOLD1,	-- if super form is applicable: will use this flash

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, <"spr2">}
		-- spr2 is optional and must be between quotes, this is to avoid compability issues with older animations

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A,  10, "SPR2_STND"},	-- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A,  10, "SPR2_STND"},		-- guarding
		anim_move =			{SPR_PLAY, A,  10, "SPR2_STND"},		-- moving
		anim_run =			{SPR_PLAY, A,  10, "SPR2_STND"},	-- guess what
		anim_atk =			{SPR_PLAY, A,  10, "SPR2_STND"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A,  10, "SPR2_STND"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A,  10, "SPR2_STND"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A,  10, "SPR2_STND"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A,  10, "SPR2_STND"},		-- is down
		anim_getup =		{SPR_PLAY, A,  10, "SPR2_STND"},		-- gets up from down
		anim_death =		{SPR_PLAY, A,  10, "SPR2_STND"},		-- dies
		anim_revive =		{SPR_PLAY, A,  10, "SPR2_STND"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A,  10, "SPR2_STND"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_PLAY, A,  10, "SPR2_STND"},		-- shooting evoker

		anim_stand_super = 	{SPR_PLAY, A,  10, "SPR2_STND"},		-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, A,  10, "SPR2_STND"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A,  10, "SPR2_STND"},		-- standing
		anim_run_super = 	{SPR_PLAY, A,  10, "SPR2_STND"},	-- run
		anim_evoker_super = 	{SPR_PLAY, A,  10, "SPR2_STND"},
		anim_evoker_shoot_super = 	{SPR_PLAY, A,  10, "SPR2_STND"},

		anim_special1 = {SPR_PLAY, A,  10, "SPR2_STND"}, -- spindash (revving up)
		anim_special2 = {SPR_PLAY, A,  10, "SPR2_STND"}, -- spindash (faster, revved up)

		-- VOICES
		-- Follow this template.
		-- All sounds in there will be *automatically* freeslotted.
		-- For custom characters, call VFX_freeslotC("skinname") OUT OF A THINKFRAME (!)
		-- See Player_Defs.LUA

		vfx_summon = {"sfx_sosum1", "sfx_sosum2", "sfx_sosum3", "sfx_sosum4", "sfx_sosum5"},
		vfx_skill = {"sfx_soskl1", "sfx_soskl2"},
		vfx_item = {"sfx_souse1"},
		vfx_hurt = {"sfx_sohrt1"},
		vfx_xhurt = {"sfx_sohtx1", "sfx_sohtx2"},
		vfx_die = {"sfx_sodie1"},
		vfx_killconfirm = {"sfx_soskl1", "sfx_soskl2"},
		vfx_heal = {"sfx_sohel1", "sfx_sohel2", "sfx_sohel3"},
		vfx_healself = {"sfx_sohel1", "sfx_sohel2", "sfx_sohel3"},
		vfx_kill = {"sfx_sokll1", "sfx_sokll2", "sfx_sokll3", "sfx_sokll4"},
		vfx_1more = {"sfx_so1mr1", "sfx_so1mr2"},
		vfx_crit = {"sfx_socrt1"},
		vfx_aoaask = {"sfx_soaoi1", "sfx_soaoi2", "sfx_soaoi3", "sfx_soaoi4"},
		vfx_aoado = {"sfx_soaoa1", "sfx_soaoa2", "sfx_soaoa3", "sfx_soaoa4"},
		vfx_aoarelent = {"sfx_somis2", "sfx_somis3"},
		vfx_miss = {"sfx_somis1", "sfx_somis2", "sfx_somis3"},
		vfx_dodge = {"sfx_sodge1"},
		vfx_win = {"sfx_sowin1", "sfx_sowin2", "sfx_sowin3", "sfx_sowin4"},
		vfx_levelup = {"sfx_solvl1", "sfx_socrt1", "sfx_sohel2", "sfx_sokll1"},


		icon = "ICO_RAND",	-- icon for net select and other menus
		hudbust = "",			-- patch to draw on the stat hud
		hudaoa = "H_SONAOA",	-- patch for all out attack hud
		hudsbust = "SSONIC_H",
		hudsaoa = "H_SSONAOA",	-- same but for supers
		hudcutin = "SONIC_A",	-- cut in
		aoa_quote = "Let's get this\nparty started!",

		tip = "Select a random character.",
	}